<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2004 Kraft Bernhard (kraftb@kraftb.at)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Hook for the unused elements of TV
 *
 * $Id$
 *
 * @author	Kraft Bernhard <kraftb@kraftb.at>
 */
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 */


class ux_tx_templavoila_mod1_sidebar extends tx_templavoila_mod1_sidebar	{

	/**
	 * Displays a list of local content elements on the page which were NOT used in the hierarchical structure of the page.
	 *
	 * @param	$pObj:		Reference to the parent object ($this)
	 * @return	string		HTML output
	 * @access private
	 */
	function renderItem_nonUsedElements (&$pObj) {
		global $LANG, $TYPO3_DB;

		$output = '';
		$elementRows = array();
		$usedUids = array_keys($pObj->global_tt_content_elementRegister);
		$usedUids[] = 0;

		$res = $TYPO3_DB->exec_SELECTquery (
			'uid, header',
			'tt_content',
			'pid='.intval($pObj->id).' AND uid NOT IN ('.implode(',',$usedUids).')'.t3lib_BEfunc::deleteClause('tt_content'),
			'',
			'uid'
		);

		while($row = $TYPO3_DB->sql_fetch_assoc($res))	{
			$isSel = (string)$this->pObj->clipObj->isSelected('tt_content', $row['uid']);
			$linkIcon = '<a href="#" onclick="'.htmlspecialchars('return jumpSelf(\''.$this->pObj->clipObj->selUrlDB('tt_content', $row['uid'], 0, ($isSel=='cut'), array('returnUrl'=>'')).'\');').'"><img'.t3lib_iconWorks::skinImg($this->doc->backPath,'gfx/clip_cut'.($isSel=='cut'?'_h':'').'.gif','width="12" height="12"').' title="'.$LANG->sL('LLL:EXT:lang/locallang_core.php:cm.cut',1).'" alt="" /></a>';

			$elementRows[] = '
				<tr class="bgColor4">
					<td>'.$linkIcon.'</td>
					<td>'.htmlspecialchars($row['header']).'</td>
				</tr>
			';
		}

		if (count ($elementRows)) {
			$output = '
				<table border="0" cellpadding="0" cellspacing="1" width="100%" class="lrPadding">
					<tr class="bgColor4-20">
						<td colspan="2">'.$LANG->getLL('inititemno_elementsNotBeingUsed','1').':</td>
					</tr>
					'.implode('',$elementRows).'
				</table>
			';
		}
		return $output;
	}

}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/kb_tv_clipboard/class.ux_tx_templavoila_mod1_sidebar.php'])    {
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/kb_tv_clipboard/class.ux_tx_templavoila_mod1_sidebar.php']);
}

?>
