<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2004 Kraft Bernhard (kraftb@kraftb.at)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * XCLASS Extension file for templa voila page module
 *
 * $Id$
 *
 * @author	Kraft Bernhard <kraftb@kraftb.at>
 */
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 */

require_once(PATH_t3lib.'class.t3lib_clipboard.php');

class ux_tx_templavoila_module1 extends tx_templavoila_module1 {
	
	
	/**
	 * Main function of the module.
	 *
	 * @return	void
	 */
	function main()    {
		global $BE_USER,$LANG,$BACK_PATH;

			// Access check! The page will show only if there is a valid page and if this page may be viewed by the user
		if (is_array($this->altRoot))	{
			$access = true;
		} else {
			$pageInfoArr = t3lib_BEfunc::readPageAccess($this->id, $this->perms_clause);
			$access = (intval($pageInfoArr['uid'] > 0));
		}

		if ($access)    {

				// Check if we have to update the pagetree:
			if (t3lib_div::_GP('updatePageTree')) {
				t3lib_BEfunc::getSetUpdateSignal('updatePageTree');
			}

			$this->showClipboard = $GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['kb_tv_clipboard']['showClipboard'];
			$this->clipObj = t3lib_div::makeInstance('t3lib_clipboard');
			$this->clipObj->backPath = $BACK_PATH;
			$this->clipObj->initializeClipboard();
			
				// Clipboard actions are handled:
			$CB = t3lib_div::_GP('CB');	// CB is the clipboard command array
			if ($this->cmd=='setCB')	{
					// CBH is all the fields selected for the clipboard, CBC is the checkbox fields which were checked. By merging we get a full array of checked/unchecked elements
					// This is set to the 'el' array of the CB after being parsed so only the table in question is registered.
				$CB['el'] = $this->clipObj->cleanUpCBC(array_merge(t3lib_div::_POST('CBH'),t3lib_div::_POST('CBC')),'tt_content');
			}
			if (!$this->MOD_SETTINGS['showClipboard'])	$CB['setP']='normal';	// If the clipboard is NOT shown, set the pad to 'normal'.
			$this->clipObj->setCmd($CB);		// Execute commands.
			$this->clipObj->cleanCurrent();	// Clean up pad
			$this->clipObj->endClipboard();	// Save the clipboard content
								
			$this->kbxmlhandler = t3lib_div::makeInstance('tx_kbtvclipboard_xmlrelhndl');


				// Draw the header.
			$this->doc = t3lib_div::makeInstance('noDoc');
			$this->doc->docType= 'xhtml_trans';
			$this->doc->backPath = $BACK_PATH;
			$this->doc->divClass = '';
			$this->doc->form='<form action="'.htmlspecialchars('index.php?'.$this->linkParams()).'" method="post" autocomplete="off">';

				// Adding classic jumpToUrl function, needed for the function menu. Also, the id in the parent frameset is configured.
			$this->doc->JScode = $this->doc->wrapScriptTags('
				function jumpToUrl(URL)	{ //
					document.location = URL;
					return false;
				}
				if (top.fsMod) top.fsMod.recentIds["web"] = '.intval($this->id).';
			');

				// Set up JS for dynamic tab menu and side bar
			$this->doc->JScode .= $this->doc->getDynTabMenuJScode();
			$this->doc->JScode .= $this->sideBarObj->getJScode();
			$this->doc->JScode .= $this->doc->wrapScriptTags('
'.$this->doc->redirectUrls().'
function jumpSelf(URL)	{	//
	document.location = URL+(T3_RETURN_URL?"&returnUrl="+T3_RETURN_URL:"");
	return false;
}
');
				// Setting up support for context menus (when clicking the items icon)
			$CMparts = $this->doc->getContextMenuCode();
			$this->doc->bodyTagAdditions = $CMparts[1];
			$this->doc->JScode.= $CMparts[0];
			$this->doc->postCode.= $CMparts[2];

				// Go through the commands and check if we have to do some action:
			$commands = array ('createNewRecord', 'unlinkRecord', 'deleteRecord','pasteRecord', 'makeLocalRecord', 'createNewTranslation');
			foreach ($commands as $cmd) {
				unset ($params);
				$params = t3lib_div::_GP($cmd);
				$function = 'cmd_'.$cmd;

					// If the current function has a parameter passed by GET or POST, call the related function:
				if ($params && is_callable(array ($this, $function))) {
				 	$this->$function ($params);
				}
			}

				// Show the "edit current page" screen along with the sidebar. The sidebar needs information which is only available after
				// rendering the edit screen, that's why we delay the output. The sidebar will only be rendered at THIS point, if its position is "left"
			$editPageScreen = $this->renderEditPageScreen ();
			$sideBar = ($this->sideBarObj->position == 'left') ? $this->sideBarObj->render($dsInfo) : FALSE;

			if ($this->MOD_SETTINGS['showClipboard'] && $this->showClipboard)	{
				$editPageScreen .= $this->clipObj->printClipboard();
			}
				// Create make-shortcut-icon:
			if ($BE_USER->mayMakeShortcut()) {
				$editPageScreen .= '<br />'.$this->doc->makeShortcutIcon('id,altRoot',implode(',',array_keys($this->MOD_MENU)),$this->MCONF['name']);
			}
				// "Show hidden" checkbox:
			$editPageScreen .= '<br />'.t3lib_BEfunc::getFuncCheck($this->id,'SET[tt_content_showHidden]',$this->MOD_SETTINGS['tt_content_showHidden'],'','').' '.$LANG->getLL('printconte_showHiddenElements','1');
			$editPageScreen .= '<br />'.t3lib_BEfunc::getFuncCheck($this->id,'SET[showClipboard]',$this->MOD_SETTINGS['showClipboard'],'','').' '.$LANG->sL('LLL:EXT:kb_tv_clipboard/locallang_db.php:printcontent_showClipboard');

				// Start creating HTML output
			$this->content .= $this->doc->startPage($LANG->getLL('title'));

			if ($sideBar) {
				$this->content .= '
					<table cellspacing="0" cellpadding="0" style="width:100%; height:550px; padding:0; margin:0;">
						<tr>
							<td style="vertical-align:top;">'.$sideBar.'</td>
							<td style="vertical-align:top; padding-bottom:20px;" width="99%">'.$editPageScreen.'</td>
						</tr>
					</table>
				';
			} else {
				$this->content .= $editPageScreen;
			}
			unset ($sideBar);
			unset ($editPageScreen);

		} else {	// No access or no current page uid:

			$this->doc = t3lib_div::makeInstance('mediumDoc');
			$this->doc->docType= 'xhtml_trans';
			$this->doc->backPath = $BACK_PATH;
			$this->content.=$this->doc->startPage($LANG->getLL('title'));

			$cmd = t3lib_div::_GP ('cmd');
			switch ($cmd) {

					// Create a new page
				case 'crPage' :
						// Output the page creation form
					$this->content .= $this->wizardsObj->renderWizard_createNewPage (t3lib_div::_GP ('positionPid'));
					break;

					// If no access or if ID == zero
				default:
					$this->content.=$this->doc->header($LANG->getLL('title'));
					$this->content.=$LANG->getLL('default_introduction');
			}
		}
		$this->content.=$this->doc->endPage();
	} // EOF: function main()    {


	/**
	 * Renders the display framework.
	 * Calls itself recursively
	 *
	 * @param	array		$dsInfo: DataStructure info array (the whole tree)
	 * @param	string		$parentPos: Pointer to parent element: table:id:sheet:structure language:fieldname:value language:counter (position in list)
	 * @param	boolean		$clipboardElInPath: Tells whether any element registered on the clipboard is found in the current "path" of the recursion. If true, it normally means that no paste-in symbols are shown since elements are not allowed to be pasted/referenced to a position within themselves (would result in recursion).
	 * @param	boolean		$referenceInPath: Is set to the number of references there has been in previous recursions of this function
	 * @param	string		$sheet: The sheet key of the sheet which should be rendered
	 * @return	string		HTML
	 */
	function renderFrameWork($dsInfo, $parentPos, $clipboardElInPath, $referenceInPath, $sheet) {
		global $LANG, $TYPO3_CONF_VARS, $TCA;

			// First prepare user defined objects (if any) for hooks which extend this function:
		$hookObjectsArr = array();
		if (is_array ($TYPO3_CONF_VARS['EXTCONF']['templavoila']['mod1']['renderFrameworkClass'])) {
			foreach ($TYPO3_CONF_VARS['EXTCONF']['templavoila']['mod1']['renderFrameworkClass'] as $classRef) {
				$hookObjectsArr[] = &t3lib_div::getUserObj ($classRef);
			}
		}

		if (!is_array($this->currentDataStructureArr[$dsInfo['el']['table']]))		{
			$this->currentDataStructureArr[$dsInfo['el']['table']] = array();
		}

			// Take care of the currently selected language, for both concepts - with langChildren enabled and disabled
		$langDisable = intval($this->currentDataStructureArr[$dsInfo['el']['table']]['meta']['langDisable']);

		$langChildren = intval ($this->currentDataStructureArr[$dsInfo['el']['table']]['meta']['langChildren']);
		$lKey = $langDisable ? 'lDEF' : ($langChildren ? 'lDEF' : 'l'.$this->currentLanguageKey);
		$vKey = $langDisable ? 'vDEF' : ($langChildren ? 'v'.$this->currentLanguageKey : 'vDEF');

			// The $isLocal flag is used to denote whether an element belongs to the current page or not. If NOT the $isLocal flag means (for instance) that the title bar will be colored differently to show users that this is a foreign element not from this page.
		$isLocal = $dsInfo['el']['table']=='pages' || $dsInfo['el']['pid']==$this->topPagePid;	// Pages have the local style
		if (!$isLocal) { $referenceInPath++; }

			// Set whether the current element is registered for copy/cut/reference or not:
		$elFromTable = $this->clipObj->elFromTable('tt_content');
		$clipboardElInPath = count($elFromTable)?0:1;

			// Set additional information to the title-attribute of the element icon:
		$extPath = '';
		if (!$isLocal)	{
			$extPath = ' - '.$LANG->getLL('path').': '.t3lib_BEfunc::getRecordPath($dsInfo['el']['pid'],$this->perms_clause,30);
		}

		$rulesStatus = $this->checkRulesForElement($dsInfo['el']['table'], $dsInfo['el']['id']);
		if (is_array($rulesStatus['error'])) {
			foreach ($rulesStatus['error'] as $errorElement) {
				$uid = is_null ($errorElement['uid']) ? 'NULL' : $errorElement['uid'];
				$this->elementBlacklist[$uid][$errorElement['fieldname']][] = array (
					'position' => $errorElement['position'],
					'message' => $errorElement['message']
				);
			}
		}

			// Evaluating the rules and set colors to warning scheme if a rule does not apply
		$elementBackgroundStyle = '';
		$elementPageTitlebarColor = isset ($this->currentDataStructureArr['pages']['ROOT']['tx_templavoila']['pageModule']['titleBarColor']) ? $this->currentDataStructureArr['pages']['ROOT']['tx_templavoila']['pageModule']['titleBarColor'] : $this->doc->bgColor2;
		$elementPageTitlebarStyle = 'background-color: '.($dsInfo['el']['table']=='pages' ? $elementPageTitlebarColor : ($isLocal ? $this->doc->bgColor5 : $this->doc->bgColor6)) .';';
		$elementCETitlebarStyle = 'background-color: '.$this->doc->bgColor4.';';
		$headerCellStyle = 'background-color: '.$this->doc->bgColor4.';';
		$cellStyle = 'border: 1px dashed #666666;';

		$errorLineBefore = $errorLineWihtin = $errorLineAfter = $errorLineCell = '';

		$parentPosArr = explode (':',$parentPos);
		$currentFieldName = $parentPosArr[4];

		if (is_array ($this->elementBlacklist[$dsInfo['el']['id']][$currentFieldName])) {
			foreach ($this->elementBlacklist[$dsInfo['el']['id']][$currentFieldName] as $tmpStatusArr) {
				switch ($tmpStatusArr['position']) {
					case 1:
						$elementBackgroundStyle = 'background-color: '. ($GLOBALS['TBE_STYLES']['templavoila_bgColorWarning'] ? $GLOBALS['TBE_STYLES']['templavoila_bgColorWarning']:'#f4b0b0') .';';
						$elementPageTitlebarStyle = 'background-color: '. ($GLOBALS['TBE_STYLES']['templavoila_bgColorPageTitleWarning'] ? $GLOBALS['TBE_STYLES']['templavoila_bgColorPageTitleWarning']:'#ef4545') .';';
						$elementCETitlebarStyle = 'background-color: '. ($GLOBALS['TBE_STYLES']['templavoila_bgColorCETitleWarning'] ? $GLOBALS['TBE_STYLES']['templavoila_bgColorCETitleWarning']:'#ef7c7c') .';';
						$errorLineWithin .= $this->doc->rfw($tmpStatusArr['message']).'<br />';
					break;
					case -1:
						$errorLineBefore .= $this->doc->rfw($tmpStatusArr['message']).'<br />';
					break;
					case 2:
						$errorLineAfter .= $this->doc->rfw($tmpStatusArr['message']).'<br />';
					default:
				}
			}
		}

			// Creating the rule compliance icon, $rulesStatus has been evaluated earlier
		if (!is_null($rulesStatus['ok'])) {
			$title = ($rulesStatus['ok'] === true ? $LANG->getLL ('ruleapplies') : $LANG->getLL ('rulefails'));
			$ruleIcon = '<img'.t3lib_iconWorks::skinImg($this->doc->backPath,t3lib_extMgm::extRelPath('templavoila').'mod1/'.($rulesStatus['ok'] === true ? 'green':'red').'led.gif','').' title="'.$title.'" border="0" alt="" style="text-align: center; vertical-align: middle;" />&nbsp;';
		}

			// Traversing the content areas ("zones" - those shown side-by-side with dotted lines in module) of the current element.
			// This part will be skipped, if we're already on the element level, ie. it will be only active if we currently parse an element with sub-elements
		$cells=array();
		$headerCells=array();
		$metaInfoAreaArr = array();

		if (is_array($dsInfo['sub'][$sheet]))	{
			foreach($dsInfo['sub'][$sheet] as $fieldID => $fieldContent)	{
				$counter=0;

					// Only show fields and values of a flexible content element, if either the currently selected language is the DEF language, or the langDisable flag of the FCE's data structure is not set
				if (!$fieldContent['meta']['langDisable'] || $this->currentLanguageKey == 'DEF') {

						// "New" and "Paste" icon:
					$elList = '';
					$elList.=$this->linkNew('<img'.t3lib_iconWorks::skinImg($this->doc->backPath,'gfx/new_el.gif','').' style="text-align: center; vertical-align: middle;" vspace="5" border="0" title="'.$LANG->getLL ('createnewrecord').'" alt="" />',$dsInfo['el']['table'].':'.$dsInfo['el']['id'].':'.$sheet.':'.$lKey.':'.$fieldID.':'.$vKey.':'.$counter);
					if (!$clipboardElInPath)	{ 
						$GLOBALS['TCA']['XML'] = 1;	// Make the clipboard class happy
						$elList .= '<a href="'.htmlspecialchars($this->clipObj->pasteUrl('XML', $dsInfo['el']['table'].':'.$dsInfo['el']['id'].':'.$sheet.':'.$lKey.':'.$fieldID.':'.$vKey.':'.$counter, 1, Array())).'" onclick="'.htmlspecialchars('return '.$this->clipObj->confirmMsg($dsInfo['el']['table'], array(),'after',$elFromTable)).'"><img'.t3lib_iconWorks::skinImg($this->doc->backPath,'gfx/clip_pasteafter.gif','width="12" height="12"').' title="'.$LANG->getLL('clip_pasteAfter',1).'" alt="" / style="text-align: center; vertical-align: middle;"></a>';
						unset($GLOBALS['TCA']['XML']);	// Make the world happy
					}

						// Render the list of elements (and possibly call itself recursively if needed):
					if (is_array($fieldContent['el_list']))	 {
						foreach($fieldContent['el_list'] as $counter => $k)	{
							$v = $fieldContent['el'][$k];
							$this->containedElements[$this->containedElementsPointer]++;
							$elList.=$this->renderFrameWork_allSheets($v,$dsInfo['el']['table'].':'.$dsInfo['el']['id'].':'.$sheet.':'.$lKey.':'.$fieldID.':'.$vKey.':'.$counter,$clipboardElInPath,$referenceInPath);

								// "New" and "Paste" icon:
							$elList.=$this->linkNew('<img'.t3lib_iconWorks::skinImg($this->doc->backPath,'gfx/new_el.gif','').' style="text-align: center; vertical-align: middle;" vspace="5" border="0" title="'.$LANG->getLL ('createnewrecord').'" alt="" />',$dsInfo['el']['table'].':'.$dsInfo['el']['id'].':'.$sheet.':'.$lKey.':'.$fieldID.':'.$vKey.':'.$counter);
							if (!$clipboardElInPath)	{
								list($targ_table, $targ_uid, $targ_rec) = $this->kbxmlhandler->getRecord($dsInfo['el']['table'].':'.$dsInfo['el']['id'].':'.$sheet.':'.$lKey.':'.$fieldID.':'.$vKey.':'.$counter);
								if (is_array($targ_rec))	{
									$GLOBALS['TCA']['XML'] = 1;	// Make the clipboard class happy
									$elList .= '<a href="'.htmlspecialchars($this->clipObj->pasteUrl('XML', $dsInfo['el']['table'].':'.$dsInfo['el']['id'].':'.$sheet.':'.$lKey.':'.$fieldID.':'.$vKey.':'.$counter, 1, Array())).'" onclick="'.htmlspecialchars('return '.$this->clipObj->confirmMsg('tt_content', $targ_rec,'after',$elFromTable)).'"><img'.t3lib_iconWorks::skinImg($this->doc->backPath,'gfx/clip_pasteafter.gif','width="12" height="12"').' title="'.$LANG->getLL('clip_pasteAfter',1).'" alt="" / style="text-align: center; vertical-align: middle;"></a>';
									unset($GLOBALS['TCA']['XML']);	// Make the world happy
								}
							}
						}
					}

						// Check if rules-related errors must be displayed for this field at the very beginning
					if (is_array ($this->elementBlacklist['NULL'][$fieldID])) {
						foreach ($this->elementBlacklist['NULL'][$fieldID] as $tmpStatusArr) {
							$headerCellStyle = 'background-color: '. ($GLOBALS['TBE_STYLES']['templavoila_bgColorCETitleWarning'] ? $GLOBALS['TBE_STYLES']['templavoila_bgColorCETitleWarning']:'#ef7c7c') .';';
							$cellStyle = 'border: 1px dashed red; ';
							$errorLineCell .= $this->doc->rfw($tmpStatusArr['message']).'<br />';
						}
					}
						// Add cell content to registers:
					$headerCells[]='<td valign="top" width="'.round(100/count($dsInfo['sub'][$sheet])).'%" style="'.$headerCellStyle.' padding-top:0; padding-bottom:0;">'.$LANG->sL($fieldContent['meta']['title'],1).'</td>';
					$cells[]='<td valign="top" width="'.round(100/count($dsInfo['sub'][$sheet])).'%" style="'.$cellStyle.' padding: 5px 5px 5px 5px;">'.$errorLineCell.$elList.'</td>';
				} else {
					$cells[]='
						<td valign="top" width="'.round(100/count($dsInfo['sub'][$sheet])).'%" style="'.$cellStyle.' padding: 5px 5px 5px 5px;">
							<em>'.htmlspecialchars ($LANG->getLL ('willbereplacedbydefaultlanguage')).'</em>
						</td>
					';
				}
			}
		}

			// Compile preview content for the current element:
		$content = is_array($dsInfo['el']['previewContent']) ? implode('<br />', $dsInfo['el']['previewContent']) : '';

			// Add language icon (which will be displayed later on):
		$langLabel = htmlspecialchars ($this->allAvailableLanguages[$dsInfo['el']['sys_language_uid']]['title']);
		$langIcon = $this->allAvailableLanguages[$dsInfo['el']['sys_language_uid']]['flagIcon'] ?
					'<img src="'.$this->allAvailableLanguages[$dsInfo['el']['sys_language_uid']]['flagIcon'].'" title="'.$langLabel.'" alt="'.$langLabel.'" style="text-align: center; vertical-align: middle;" />' :
					($langLabel && $dsInfo['el']['sys_language_uid'] ? '['.$langLabel.']' : '');

			// Compile the content areas for the current element (basically what was put together above):
		if (count ($headerCells) || count ($cells)) {
			$content .= '
				<table border="0" cellpadding="2" cellspacing="2" width="100%">
					<tr>'.(count($headerCells) ? implode('',$headerCells) : '<td>&nbsp;</td>').'</tr>
					<tr>'.(count($cells) ? implode('',$cells) : '<td>&nbsp;</td>').'</tr>
				</table>
			';
		}

			// Put together the records icon including content sensitive menu link wrapped around it:
		$recordIcon = '<img'.t3lib_iconWorks::skinImg($this->doc->backPath,$dsInfo['el']['icon'],'').' style="text-align: center; vertical-align: middle;" width="18" height="16" border="0" title="'.htmlspecialchars('['.$dsInfo['el']['table'].':'.$dsInfo['el']['id'].']'.$extPath).'" alt="" />';
		$recordIcon = $this->doc->wrapClickMenuOnIcon($recordIcon,$dsInfo['el']['table'],$dsInfo['el']['id'],1,'&callingScriptId='.rawurlencode($this->doc->scriptID), 'new,copy,cut,pasteinto,pasteafter,delete');

#		$realDelete = $isLocal;	// content elements that are NOT references from other pages will be deleted when unlinked
		$realDelete = FALSE;	// Eventually it seems that deleting content elements is not a good long term idea. Therefore, regardless of situation, we ALWAYS unlink - unused Content Elements can be cleaned up by some other tool some other day.

		$linkCustom = $linkCopy = $linkCut = $linkRef = $linkUnlink = $linkMakeLocal = $titleBarTDParams = $contentWrapPre = $contentWrapPost = '';

		if ($dsInfo['el']['table']!='tt_content')	{

			$viewPageIcon = '<a href="#" onclick="'.htmlspecialchars(t3lib_BEfunc::viewOnClick($dsInfo['el']['table']=='pages'?$dsInfo['el']['id']:$dsInfo['el']['pid'],$this->doc->backPath,t3lib_BEfunc::BEgetRootLine($dsInfo['el']['id']),'','',($this->currentLanguageUid?'&L='.$this->currentLanguageUid:''))).'">'.
				'<img'.t3lib_iconWorks::skinImg($this->doc->backPath,'gfx/zoom.gif','width="12" height="12"').' title="'.$LANG->sL('LLL:EXT:lang/locallang_core.php:labels.showPage',1).'" hspace="3" alt="" style="text-align: center; vertical-align: middle;" />'.
				'</a>';
			if ($this->sideBarObj->position == 'toprows' || $this->sideBarObj->position == 'toptabs') {
				$contentWrapPre .= $this->sideBarObj->render($dsInfo);
			}

		} else {
			$linkMakeLocal = (!$isLocal && $referenceInPath<=1) ? $this->linkMakeLocal('<img'.t3lib_iconWorks::skinImg($this->doc->backPath,t3lib_extMgm::extRelPath('templavoila').'mod1/makelocalcopy.gif','').' title="'.$LANG->getLL('makeLocal').'" border="0" alt="" />', $parentPos.'/'.$dsInfo['el']['table'].':'.$dsInfo['el']['id'].'/'.$isLocal.'/'.$this->id) : '';
				// Check if clipboard object is selected.
			$isSel = (string)$this->clipObj->isSelected($dsInfo['el']['table'],$dsInfo['el']['id']);
			if (!$isSel) {
				$isSel = (string)$this->clipObj->isSelected('XML', $parentPos.'/'.$dsInfo['el']['table'].':'.$dsInfo['el']['id'].'/'.$isLocal.'/'.$this->id);
			}
				// Replaced links for Copy, Cut, and Reference	
			$linkCopy='<a href="#" onclick="'.htmlspecialchars('return jumpSelf(\''.$this->clipObj->selUrlDB('XML', $parentPos.'/'.$dsInfo['el']['table'].':'.$dsInfo['el']['id'].'/'.$isLocal.'/'.$this->id,1,($isSel=='copy'),array('returnUrl'=>'')).'\');').'"><img'.t3lib_iconWorks::skinImg($this->doc->backPath,'gfx/clip_copy'.($isSel=='copy'?'_h':'').'.gif','width="12" height="12"').' title="'.$LANG->sL('LLL:EXT:lang/locallang_core.php:cm.copy',1).'" alt="" /></a>';
			$linkCut = '<a href="#" onclick="'.htmlspecialchars('return jumpSelf(\''.$this->clipObj->selUrlDB('XML', $parentPos.'/'.$dsInfo['el']['table'].':'.$dsInfo['el']['id'].'/'.$isLocal.'/'.$this->id ,0,($isSel=='cut'),array('returnUrl'=>'')).'\');').'"><img'.t3lib_iconWorks::skinImg($this->doc->backPath,'gfx/clip_cut'.($isSel=='cut'?'_h':'').'.gif','width="12" height="12"').' title="'.$LANG->sL('LLL:EXT:lang/locallang_core.php:cm.cut',1).'" alt="" /></a>';
			$linkRef = '<a href="#" onclick="'.htmlspecialchars('return jumpSelf(\''.$this->clipObj->selUrlDB('XML', $parentPos.'/'.$dsInfo['el']['table'].':'.$dsInfo['el']['id'].'/'.$isLocal.'/'.$this->id ,2,($isSel=='ref'),array('returnUrl'=>'')).'\');').'"><img'.t3lib_iconWorks::skinImg($this->doc->backPath,t3lib_extMgm::extRelPath('templavoila').'mod1/clip_ref'.($isSel=='ref'?'_h':'').'.gif','').' title="'.$LANG->sL('LLL:EXT:lang/locallang_core.php:cm.cut',1).'" alt="" /></a>';

   			$linkUnlink = $this->linkUnlink('<img'.t3lib_iconWorks::skinImg($this->doc->backPath,'gfx/garbage.gif','').' title="'.$LANG->getLL($realDelete ? 'deleteRecord' : 'unlinkRecord').'" border="0" alt="" />', $parentPos.'/'.$dsInfo['el']['table'].':'.$dsInfo['el']['id'].'/'.$isLocal, $realDelete);

			if (is_array ($dsInfo['sub']) && $this->altRoot['uid'] != $dsInfo['el']['id']) {
				$viewSubElementsUrl = 'index.php?id='.$this->id.
					'&altRoot[table]='.rawurlencode($dsInfo['el']['table']).
					'&altRoot[uid]='.$dsInfo['el']['id'].
					'&altRoot[field_flex]=tx_templavoila_flex';
				$titleBarTDParams .= ' onClick="jumpToUrl(\''.$viewSubElementsUrl.'\');"';
				$titleBarTDParams .= ' style="cursor:pointer;cursor:hand" title="'.htmlspecialchars($LANG->getLL ('viewsubelements')).'"';
			}
		}

			// Create informational table about localized versions of elements
		$llTable = $this->renderLocalizationInfoTable ($dsInfo);

			// Hook: renderFrameWork_preProcessOutput
		reset($hookObjectsArr);
		while (list(,$hookObj) = each($hookObjectsArr)) {
			if (method_exists ($hookObj, 'renderFrameWork_preProcessOutput')) {
				$hookObj->renderFrameWork_preProcessOutput ($dsInfo, $sheet, $content, $isLocal, $linkCustom, $this);
			}

		}

		$finalContent =
			($errorLineBefore ? '<br />'.$errorLineBefore : ''). '
		<table border="0" cellpadding="0" cellspacing="0" style="border: 1px solid black; margin-bottom:5px; '.$elementBackgroundStyle.'" width="100%">
			<tr style="'.$elementPageTitlebarStyle.';">
				<td nowrap="nowrap">'.$ruleIcon.$langIcon.$recordIcon.$viewPageIcon.'</td><td width="95%" '.$titleBarTDParams.'>'.($isLocal?'':'<em>').htmlspecialchars($dsInfo['el']['title']).($isLocal?'':'</em>'). '</td>
				<td nowrap="nowrap" align="right" valign="top">'.
					$linkCustom.
					$linkMakeLocal.
					$linkCopy.
					$linkCut.
					$linkRef.
					$linkUnlink.
					($isLocal ? $this->linkEdit('<img'.t3lib_iconWorks::skinImg($this->doc->backPath,'gfx/edit2.gif','').' title="'.$LANG->getLL ('editrecord').'" border="0" alt="" />',$dsInfo['el']['table'],$dsInfo['el']['id']) : '').
				'</td>
			</tr>
			<tr>
				<td colspan="3">'.
					$contentWrapPre.
					$content.
					($errorLineWithin ? '<br />'.$errorLineWithin : '').
					$llTable.
					$contentWrapPost.
				'</td>
			</tr>
		</table>
		'.$errorLineAfter.'
		';
		return $finalContent;
	} // EOF: function renderFrameWork($dsInfo, $parentPos, $clipboardElInPath, $referenceInPath, $sheet) {
} // EOF: class ux_tx_templavoila_module1 extends tx_templavoila_module1 {


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/kb_tv_clipboard/class.ux_tx_templavoila_module1.php'])    {
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/kb_tv_clipboard/class.ux_tx_templavoila_module1.php']);
}

?>
